﻿using Blazor.Models;
using Blazorise.Extensions;
using Microsoft.AspNetCore.Components;

namespace Blazor.Components
{
    public partial class ItemInventory
    {
        [Parameter]
        public bool NoDrop { get; set; }

        [Parameter]
        public InventoryItem Items { get; set; }

        [Parameter]
        public int Index { get; set; }

        [CascadingParameter]
        public Inventory Parent { get; set; }

        public void OnDragStart()
        {
            if(!NoDrop)
            {
                return;
            }
            Parent.CurrentDragItem = this.Items;
            Parent.inventory.inventoryItems[Index] = null;
            Parent.update();
        }
        

        public void OnDrop()
        {
            if (!NoDrop)
            {
                this.Items = Parent.CurrentDragItem;
                NoDrop = true;
            }

            if (Parent.CurrentDragItem != this.Items)
            {
                InventoryItem tmp = Parent.CurrentDragItem;
                Parent.CurrentDragItem = this.Items;
                this.Items = tmp;
            }
            else
            {       
                int total = Parent.CurrentDragItem.Stack + this.Items.Stack;
                if (total >this.Items.item.StackSize)
                {
                    this.Items.Stack = this.Items.item.StackSize;
                    Parent.CurrentDragItem.Stack=total - this.Items.item.StackSize;
                }
                else
                {
                    this.Items.Stack = total;
                }
            }
        }
        internal void OnDragEnter()
        {
            Parent.Actions.Add(new InventoryAction  { Action = "Drag Enter", Item = this, Index = this.Index });
        }

        internal void OnDragLeave()
        {
            Parent.Actions.Add(new InventoryAction { Action = "Drag Leave", Item = this, Index = this.Index });
        }
    }
}
